﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Interactivity;
using Infragistics.Controls.Menus;
using System.Windows.Input;
using System.Windows;

namespace XamMenuItemCommandBehavior.Behaviors
{
    public class XamMenuItemCommandBehavior : Behavior<XamMenuItem>
    {
        public static readonly DependencyProperty CommandProperty = DependencyProperty.Register("Command", typeof(ICommand), typeof(XamMenuItemCommandBehavior), null);
        public ICommand Command
        {
            get { return (ICommand)GetValue(CommandProperty); }
            set { SetValue(CommandProperty, value); }
        }

        public static readonly DependencyProperty CommandParamenterProperty = DependencyProperty.Register("CommandParamenter", typeof(object), typeof(XamMenuItemCommandBehavior), null);
        public object CommandParamenter
        {
            get { return (object)GetValue(CommandParamenterProperty); }
            set { SetValue(CommandParamenterProperty, value); }
        }

        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.Click += AssociatedObject_Click;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.Click -= AssociatedObject_Click;
            base.OnDetaching();
        }

        private void AssociatedObject_Click(object sender, EventArgs e)
        {
            if (Command != null && Command.CanExecute(CommandParamenter))
                Command.Execute(CommandParamenter);
        }
    }
}
